﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using Telerik.Windows.Data;
using Telerik.Windows.Controls.GridView;
using Telerik.Windows;

namespace Cell_RowSelection_SL
{
	public partial class MainPage : UserControl
	{
		public MainPage()
		{
			InitializeComponent();

			//EventManager.RegisterClassHandler(typeof(MainPage), RadGridView.MouseLeftButtonDownEvent, new MouseButtonEventHandler(playersGrid_MouseLeftButtonDown), true);
			this.AddHandler(RadGridView.MouseLeftButtonDownEvent, new MouseButtonEventHandler(playersGrid_MouseLeftButtonDown), true);
			//this.playersGrid.MouseLeftButtonDown += new MouseButtonEventHandler(playersGrid_MouseLeftButtonDown);
		}
	
		void playersGrid_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
		{
			if (this.playersGrid.SelectionUnit != GridViewSelectionUnit.Cell)
			{
				var element = e.OriginalSource as FrameworkElement;
				var cell = element.ParentOfType<GridViewCell>();

				if (cell != null)
				{
					this.playersGrid.SelectionUnit = GridViewSelectionUnit.Cell;
					var cellInfo = new GridViewCellInfo(cell);
					this.playersGrid.SetSelectionAnchor(cellInfo);
					this.playersGrid.SelectedCells.Add(cellInfo);
				}
			}
		}

		private void playersGrid_RowLoaded(object sender, Telerik.Windows.Controls.GridView.RowLoadedEventArgs e)
		{
			GridViewRow row = e.Row as GridViewRow;
			if (row != null)
			{
				Border indicatorPresenter = row.ChildrenOfType<Border>().Where(b => b.Name == "PART_IndicatorPresenter").FirstOrDefault();
				indicatorPresenter.MouseLeftButtonDown += new MouseButtonEventHandler(indicatorPresenter_MouseLeftButtonDown);
			}	
		}

		private void indicatorPresenter_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
		{
			if (this.playersGrid.SelectionUnit != GridViewSelectionUnit.FullRow)
			{
				var border = sender as Border;
				var row = border.ParentOfType<GridViewRow>();

				this.playersGrid.SelectionUnit = GridViewSelectionUnit.FullRow;

				this.playersGrid.SelectedItem = row.Item;
				this.playersGrid.SetSelectionAnchor(row.Item);
			}
		}
	}
}
